# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import langlib
import popuplib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func = es.import_addon('sam/functions')

# * VARIABLES

# '''''''''''''''''''''' # Languages # ''''''''''''''''''''' #
langDir     = es.getAddonPath('sam') + '/langs/addons/'
popupText   = langlib.Strings(langDir + 'popups.ini')
actionsText = langlib.Strings(langDir + 'actions.ini')
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

folder = 'sam/base/addons/'
db     = 'sam_addons'
db_dir = 'cstrike/cfg/sam/databases/es_sam_addons_db.txt'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	''' Load Keygroup '''
	if os.path.isfile(db_dir) == True: es.keygroupload(db, func.default.dbfiles)
	else: es.keygroupcreate(db)

	''' Load Addons '''
	if len(getAddonsList()) > 0:
		for item in getAddonsList():
			if isAddonReg(item):
				if int(es.keygetvalue(db, item, 'status')) == 1:
					es.load('sam/base/addons/' + item)
					updateAddon(item)
			else: regAddon(item)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	''' Deletes '''
	if es.exists('keygroup', db) == 1: es.keygroupdelete(db)

	''' Unloads '''
	for item in getAddonsList():
		if es.ServerVar('sam_' + item) == 1: es.unload('sam/base/addons/' + item)

	''' Popups '''
	func.popupDelete('addonsList')
	func.popupDelete('addonsPage')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def modulePopup(userid):
	func.popupDelete('addonsList')
	popup = popuplib.easymenu('addonsList', None , addonPage)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
	popup.setdescription('\n \n :: ' + popupText('addonsList_desc', None, func.getLang()))

	if len(getAddonsList()) > 0:
		for item in getAddonsList():
			addon = getAddon(item)
			popup.addoption(item, '%s' % addon['name'])
		popup.submenu(10, 'mainPage')
		popup.send(userid)
	else:
		func.hudhint(userid, func.commonText('noAddons', None, func.getLang()))
		block = es.import_addon('sam/base')
		block.displayMenu(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def addonPage(userid, addon, popup):
	func.popupDelete('addonsPage')
	global temp
	temp  = '%s_%s' % (userid,addon)
	addon = getAddon(addon)
	func.popupDelete('addonsPage')
	popup = popuplib.create('addonsPage')
	popup.addline('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
	popup.addline('\n \n :: ' + func.commonText('mainPage_addons', None, func.getLang()))
	popup.addline(func.pline)
	popup.addline(' # %s: %s' % (func.commonText('name', None, func.getLang()), addon['name']))
	popup.addline(' # %s: %s' % (popupText('version', None, func.getLang()), addon['version']))
	popup.addline(' :: %s ::\n- %s.' % (popupText('desc', None, func.getLang()), addon['desc']))
	popup.addline(' ')
	if es.ServerVar('sam_' + addon['basename']) == 1: popup.addline('STATUS: %s' % (popupText('on', None, func.getLang())))
	else: popup.addline('STATUS: %s' % (popupText('off', None, func.getLang())))
	popup.addline(' ')
	popup.addline('->     1. %s | 2. %s | 3. %s' % (popupText('load', None, func.getLang()),popupText('unload', None, func.getLang()),popupText('reload', None, func.getLang())))
	popup.addline(func.pline)
	popup.addline('->8. ' + func.commonText('back', None, func.getLang()))
	popup.addline(' ')
	popup.addline('0. ' + func.commonText('cancel', None, func.getLang()))
	popup.select(1, addonLoad)
	popup.select(2, addonUnload)
	popup.select(3, addonReload)
	popup.menuselect = addonPageChoice
	popup.send(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def addonPageChoice(userid, choice, popup):
	if choice in range(1,4):
		es.keygroupsave(db, func.default.dbfiles)
		addonPage(userid, temp.replace('%s_' % (userid),''), None)
	elif choice in range(4,8) or choice in [9,10]: func.popupDelete(popup)
	else:
		block = es.import_addon('sam/base')
		block.displayMenu(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def addonLoad(userid, choice, popup):
	addon = getAddon(temp.replace('%s_' % (userid),''))
	if es.ServerVar('sam_' + addon['basename']) == 0:
		es.load(folder + addon['basename'])
		es.set('sam_' + addon['basename'], 1)
		es.keysetvalue(db, addon['basename'], 'status', 1)
		func.hudhint(userid, actionsText('isNowEnabled', {'addon':addon['name']}, func.getLang()))
	else: func.hudhint(userid, actionsText('isEnabled', {'addon':addon['name']}, func.getLang()))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def addonUnload(userid, choice, popup):
	addon = getAddon(temp.replace('%s_' % (userid),''))
	if es.ServerVar('sam_' + addon['basename']) == 1:
		es.unload(folder + addon['basename'])
		es.set('sam_' + addon['basename'], 0)
		es.keysetvalue(db, addon['basename'], 'status', 0)
		func.hudhint(userid, actionsText('isNowDisabled', {'addon':addon['name']}, func.getLang()))
	else: func.hudhint(userid, actionsText('isDisabled', {'addon':addon['name']}, func.getLang()))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def addonReload(userid, choice, popup):
	addon = getAddon(temp.replace('%s_' % (userid),''))
	es.reload(folder + addon['basename'])
	es.set('sam_' + addon['basename'], 1)
	es.keysetvalue(db, addon['basename'], 'status', 1)
	func.hudhint(userid, actionsText('isNowEnabled', {'addon':addon['name']}, func.getLang()))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getAddonsList():
	dir        = es.getAddonPath('sam') + '/base/addons/'
	list       = os.listdir(dir)
	addonsList = []
	for item in list:
		if os.path.isdir(dir + item) == True: addonsList.append(item)
	return addonsList

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def isAddonReg(addon):
	if es.exists('key', db, addon) == True: return True
	else: False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def regAddon(addon):
	es.load('sam/base/addons/%s' % addon)
	block            = es.import_addon('sam/base/addons/%s' % addon)
	info             = {}
	info['name']     = block.addon.name
	info['desc']     = block.addon.desc
	info['basename'] = block.addon.basename
	info['version']  = block.addon.version
	if es.exists('key', db, addon) == 0: es.keycreate(db, addon)
	for item in info: es.keysetvalue(db, addon, item, info[item])
	es.keysetvalue(db, addon, 'status', 1)
	es.keygroupsave(db, func.default.dbfiles)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def updateAddon(addon):
	block = es.import_addon('sam/base/addons/%s' % addon)
	es.keysetvalue(db, addon, 'desc', block.addon.desc)
	es.keysetvalue(db, addon, 'version', block.addon.version)
	es.keygroupsave(db, func.default.dbfiles)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getAddon(addon):
	info = {
			'name':es.keygetvalue(db, addon, 'name'),
			'version':es.keygetvalue(db, addon, 'version'),
			'desc':es.keygetvalue(db, addon, 'desc'),
			'basename':es.keygetvalue(db, addon, 'basename'),
			'status':es.keygetvalue(db, addon, 'status')
			}
	return info

# ============================================================================================================================================================= #