# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import playerlib
import popuplib
import cmdlib
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

# '''''''''''''''''''''' # Languages # ''''''''''''''''''''' #
langDir     = es.getAddonPath('sam') + '/langs/pcontrol/'
actionsText = langlib.Strings(langDir + 'actions.ini')
popupText   = langlib.Strings(langDir + 'popups.ini')
tag = '#green' + func.commonText('tag_moveplayers', None, func.getLang()).upper()
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

teams = {
		1:'#spec%s' % func.commonText('spec', None, func.getLang()),
		2:'#red%s' % func.commonText('t', None, func.getLang()),
		3:'#blue%s' % func.commonText('ct', None, func.getLang())
		}

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	''' Popups '''
	func.popupDelete('teamChange')
	func.popupDelete('oppositeteams')
	func.popupDelete('moveTospectator')
	func.popupDelete('moveToteams')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid):
	func.popupDelete('teamChange')
	popup = popuplib.create('teamChange')
	popup.addline('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
	popup.addline('\n \n :: ' + popupText('moveplayersTitle', None, func.getLang()))
	popup.addline('-' * 45)
	popup.addline('->1. ' + func.commonText('spec', None, func.getLang()))
	popup.addline('->2. ' + func.commonText('t', None, func.getLang()))
	popup.addline('->3. ' + func.commonText('ct', None, func.getLang()))
	popup.addline('->4. ' + popupText('oppositeTeam', None, func.getLang()))
	popup.addline('->5. ' + popupText('switchTeams', None, func.getLang()))
	popup.addline('->6. ' + popupText('allSpec', None, func.getLang()))
	popup.addline(' ')
	popup.addline('-' * 45)
	popup.addline('->8. ' + func.commonText('back', None, func.getLang()))
	popup.addline(' ')
	popup.select(1, moveTospectator)
	popup.select(2, moveToteams)
	popup.select(3, moveToteams)
	popup.select(4, oppositeTeam)
	popup.select(5, switchTeams)
	popup.select(6, allSpec)
	popup.menuselect = teamChangeChoice
	popup.send(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def teamChangeChoice(userid, choice, popup):
	if choice in range(5,8) or choice == 9: moduleAction(userid)
	elif choice == 8:
		block = es.import_addon('sam/base')
		block.displayMenu(userid)
	elif choice == 10: func.popupDelete(popup)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def moveTospectator(userid, choice, popup):
	alive = playerlib.getPlayerList('#alive')

	if len(alive) > 0:
		func.popupDelete('moveTospectator')
		popup = popuplib.easymenu('moveTospectator', None, moveTospectatorChoice)
		popup.c_beginsep = '-' * 45
		popup.c_pagesep  = '-' * 45
		popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: ' + popupText('moveplayersDesc', None, func.getLang()))
		for player in playerlib.getPlayerList('#alive'): popup.addoption(player, player.name)
		popup.submenu(10, 'teamChange')
		popup.send(userid)
	else:
		func.hudhint(userid, func.commonText('noPlayersInTeams', None, func.getLang()))
		moduleAction(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def moveTospectatorChoice(userid, choice, popup):
	es.server.queuecmd('es_xchangeteam %s 1' % (choice))
	moduleAction(userid)
	tokens = {'target':choice.name,'team':teams[1]}
	func.msg(actionsText('moved', tokens, func.getLang()), tag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def moveToteams(userid, choice, popup):
	spec = playerlib.getPlayerList('#spec')
	ct   = playerlib.getPlayerList('#ct')
	t    = playerlib.getPlayerList('#t')
	if choice == 2: total = len(ct) + len(spec)
	elif choice == 3: total = len(t) + len(spec)
	
	if total > 0:
		func.popupDelete('moveToteams')
		popup = popuplib.easymenu('moveToteams', None, moveToteamsChoice)
		popup.c_beginsep = '-' * 45
		popup.c_pagesep  = '-' * 45
		popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: ' + popupText('moveplayersDesc', None, func.getLang()))
		for ply in playerlib.getPlayerList('#spec'): popup.addoption({'target':ply,'id':choice}, '%s [SPEC]' % ply.name)
		if choice == 2:
			for ply in ct: popup.addoption({'target':ply,'id':choice}, '%s [CT]' % ply.name)
		elif choice == 3:
			for ply in t: popup.addoption({'target':ply,'id':choice}, '%s [T]' % ply.name)
		popup.submenu(10, 'teamChange')
		popup.send(userid)
	else:
		func.hudhint(userid, func.commonText('noPlayersInTeams', None, func.getLang()))
		moduleAction(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def moveToteamsChoice(userid, choice, popup):
	target = playerlib.getPlayer(choice['target'])
	es.server.queuecmd('es_xchangeteam %s %s' % (target,choice['id']))
	moduleAction(userid)
	tokens = {'target':target.name,'team':teams[int(choice['id'])]}
	func.msg(actionsText('moved', tokens, func.getLang()), tag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def oppositeTeam(userid, choice, popup):
	alive = playerlib.getPlayerList('#alive')
	if len(alive) > 0:
		func.popupDelete('oppositeTeams')
		popup = popuplib.easymenu('oppositeTeams', None, oppositeTeamsChoice)
		popup.c_beginsep = '-' * 45
		popup.c_pagesep  = '-' * 45
		popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: ' + popupText('moveplayersDesc', None, func.getLang()))
		for player in alive:
			if player.teamid == 2: popup.addoption(player, '%s [T]' % (player.name))
			elif player.teamid == 3: popup.addoption(player, '%s [CT]' % (player.name))
		popup.submenu(10, 'teamChange')
		popup.send(userid)
	else:
		func.hudhint(userid, func.commonText('noPlayersInTeams', None, func.getLang()))
		moduleAction(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def oppositeTeamsChoice(userid, choice, popup):
	if int(choice.teamid) == 2:
		num = 3
		es.server.queuecmd('es_xchangeteam %s 3' % (choice))
	elif int(choice.teamid) == 3:
		num = 2
		es.server.queuecmd('es_xchangeteam %s 2' % (choice))
	moduleAction(userid)
	tokens = {'target':choice.name,'team':teams[num]}
	func.msg(actionsText('moved', tokens, func.getLang()), tag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def switchTeams(userid, choice, popup):
	if len(playerlib.getPlayerList('#alive')) > 0:
		ct = playerlib.getPlayerList('#ct')
		t  = playerlib.getPlayerList('#t')
		for ply in ct: es.server.queuecmd('es_xchangeteam %s 2' % ply)
		for ply in t: es.server.queuecmd('es_xchangeteam %s 3' % ply)
		func.msg(actionsText('teamsSwitched', None, func.getLang()), tag)
	else: func.hudhint(userid, func.commonText('noPlayersInTeams', None, func.getLang()))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def allSpec(userid, choice, popup):
	if len(playerlib.getPlayerList('#alive')) > 0:
		for ply in playerlib.getPlayerList('#alive'): es.server.queuecmd('es_xchangeteam %s 1' % (ply.userid))
		func.msg(actionsText('allMovedSpec', None, func.getLang()), tag)
	else: func.hudhint(userid, func.commonText('noPlayersInTeams', None, func.getLang()))

# ============================================================================================================================================================= #